(*          file: g-ne.ml
        created: Thu Feb 28 09:17:43 PST 2008
   first author: E Stabler stabler@ucla.edu

   Example grammar given by (i) feature to string translations (moverString, catString)
                            (ii) size parameters (moverMax,catMax)
                            (iii) the list of lexical items, and 
                            (iv) some examples (at least zero of them! so that the function is defined). 

       This grammar is inspired by Mahajan 2000
*)
let moverString f = List.assoc f [(0,"v"); (1,"k"); (2,"wh"); ];;
let moverMax = 2;;

let catString f = List.assoc f [(0,"d"); (1,"vt"); (2,"pred"); (3,"v"); (4,"c"); (5,"i"); ];;
let catMax = 5;;

let grammar = [
   ([], [Sel 5; Cat 4; ]); 
   ([], [Sel 5; Pos 2; Cat 4; ]); 
   ([], [Sel 3; Cat 2; ]); 
   ([], [Sel 1; Pos 1; Sel 0; Cat 2; ]); 
   (["-s"], [Sel 2; Pos 0; Pos 1; Cat 5; ]); 
   (["laugh"], [Sel 0; Cat 3; Neg 0; ]); 
   (["lavinia"], [Cat 0; Neg 1; ]); 
   (["praise"], [Sel 0; Cat 1; Neg 0; ]); 
   (["titus"], [Cat 0; Neg 1; ]); 
   (["who"], [Cat 0; Neg 1; Neg 2; ]); 
];;

(* apply cky to example with: eg grammar 1 *)
let example = function  (* (startCategory, inputString) pairs *)
     1 -> (4,["titus";"praise";"-s";"lavinia"])
  |  2 -> (4,["who";"titus";"praise";"-s"])
  |  3 -> (4,["who";"praise";"-s";"lavinia"])
  | -1 -> (4,["titus";"praise";"-s"])
  | _ -> raise (failwith "No such example");;
