(*          file: g-nta.ml
        created: Thu Feb 28 09:17:43 PST 2008
   first author: E Stabler stabler@ucla.edu

   Example grammar given by (i) feature to string translations (moverString, catString)
                            (ii) size parameters (moverMax,catMax)
                            (iii) the list of lexical items, and 
                            (iv) some examples (at least zero of them! so that the function is defined). 

   We could write a program to generate the numbering of categories 
   and these other parameters, but for now we do it by hand.
*)
let moverString f = List.assoc f [(0,"k"); (1,"i"); ];;
let moverMax = 1;;

let catString f = List.assoc f [(0,"T"); (1,"v"); (2,"D"); (3,"V"); ];;
let catMax = 3;;

let grammar = [
   ([], [Sel 3; Sel 2; Cat 1; Neg 1; ]); 
   (["-s"], [Sel 1; Pos 1; Pos 0; Cat 0; ]); 
   (["Beatrice"], [Cat 2; Neg 0; ]); 
   (["Benedick"], [Cat 2; Neg 0; ]); 
   (["and"], [Sel 0; Sel 0; Cat 0; ]); 
   (["criticize"], [Sel 2; Pos 0; Cat 3; ]); 
   (["cry"], [Cat 3; ]); 
   (["laugh"], [Cat 3; ]); 
   (["praise"], [Sel 2; Pos 0; Cat 3; ]); 
];;

(* apply cky to example with: eg grammar 1 *)
let example = function  (* (startCategory, inputString) pairs *)
    1 -> (0,["Beatrice";"Benedick";"criticize";"-s"])
  | 2 -> (0,["Benedick";"cry";"-s"])
  | 3 -> (0,["Beatrice";"Benedick";"criticize";"-s";"and";"Benedick";"cry";"-s"])
  | -1 -> (0,["Benedick";"criticize";"-s"])
  | -2 -> (0,["Beatrice";"Benedick";"cry";"-s"])
  | _ -> raise (failwith "No such example");;
