(*          file: g0.ml
        created: Thu Feb 28 09:17:43 PST 2008
   first author: E Stabler stabler@ucla.edu

   Example grammar given by (i) feature to string translations (moverString, catString)
                            (ii) size parameters (moverMax,catMax)
                            (iii) the list of lexical items, and 
                            (iv) some examples (at least zero of them! so that the function is defined). 

   We could write a program to generate the numbering of categories 
   and these other parameters, but for now we do it by hand.
*)
let moverString f = List.assoc f [(0,"k"); (1,"wh")];;
let moverMax = 1;;      (* so the movers are 0,1 *)

let catString f = List.assoc f [(0,"C"); (1,"T"); (2,"D"); (3,"N"); (4,"V"); (5,"v")];;
let catMax = 5;;        (* so the categories are 0,1,2,3,4,5 *)

let grammar =[ 
   ([], [Sel 1; Cat 0]);                 ([], [Sel 1; Pos 1; Cat 0]);
   ([], [Sel 5; Pos 0; Cat 1]);          ([], [Sel 4; Sel 2; Cat 5]);
   (["eat"], [Sel 2; Pos 0; Cat 4]);     (["laugh"], [Cat 4]);
   (["the"], [Sel 3; Cat 2; Neg 0]);     (["which"], [Sel 3; Cat 2; Neg 0; Neg 1]);
   (["king"], [Cat 3]);                  (["pie"], [Cat 3]);
];;

(* Apply cky to example 1 with: (eg g0 1). Use neg ints for examples that should fail.*)
let example = function  (* (startCategory, inputString) pairs *)
    1 -> (0,["the";"king";"laugh"])
  | 2 -> (0,["the";"king";"the";"pie";"eat"])
  | 3 -> (0,["which";"pie";"the";"king";"eat"])
  | -1 -> (0,["the";"king";"the";"pie";"laugh"])
  | -2 -> (0,["the";"king";"pie";"eat"])
  | -3 -> (0,["which";"pie";"the";"king";"eat";"the";"pie"])
  | _ -> raise (failwith "No such example");;
(****** end g0.ml ******)
