(*          file: g4.ml
        created: 2008-03-03 15:58:12 PDT
   first author: E Stabler stabler@ucla.edu

   grammar for the copy language {XX| X\in{a,b}*}

   Example grammar given by (i) feature to string translations (moverString, catString)
                            (ii) size parameters (moverMax,catMax)
                            (iii) the list of lexical items, and 
                            (iv) some examples (at least zero of them! so that the function is defined). 

   We could write a program to generate the numbering of categories 
   and these other parameters, but for now we do it by hand.
*)
let moverString f = List.assoc f [(0,"l"); (1,"r"); ];;
let moverMax = 1;;

let catString f = List.assoc f [(0,"Y"); (1,"B"); (2,"A"); (3,"T"); ];;
let catMax = 3;;

let grammar = [
   ([], [Cat 3; ]); 
   ([], [Cat 3; Neg 1; Neg 0; ]); 
   ([], [Sel 3; Pos 1; Pos 0; Cat 3; ]); 
   (["a"], [Sel 2; Pos 0; Cat 3; Neg 0; ]); 
   (["a"], [Sel 3; Pos 1; Cat 2; Neg 1; ]); 
   (["b"], [Sel 1; Pos 0; Cat 3; Neg 0; ]); 
   (["b"], [Sel 3; Pos 1; Cat 1; Neg 1; ]); 
];;

(* Apply cky to example 1 with: (eg grammar 1). Use neg ints for examples that should fail.*)
let example = function  (* (startCategory, inputString) pairs *)
    0 -> (3,[])
  | 1 -> (3,["a";"a"])
  | 2 -> (3,["a";"b";"a";"b"])
  | 3 -> (3,["a";"b";"b";"a";"b";"b"])
  | 4 -> (3,["a";"b";"b";"b";"a";"b";"b";"b"])
  | -1 -> (3,["a"])
  | -2 -> (3,["a";"b"])
  | -3 -> (3,["a";"b";"a"])
  | _ -> raise (failwith "No such example");;
